/*   C-program for use by power method animation program    */
#include <stdio.h>
void powr(double *x,double *y,long *nn)
{
    void gs(double *x,double *r,long n,long p);
    long i,j;
    double *now;
/*-------------------------------------------------------------------
   by using static variables, the function can be called repeatedly
   from xlisp-stat and it can "remember" the current estimates of
   eigenvalues and vectors
---------------------------------------------------------------------*/
    static long first = 1,opt = 2;
    static double *myx,*r,*work;
    long n = *nn;
 
    if(first){
     /* allocate memory for a private copy of x */
        if((myx = (double*)malloc((unsigned)(n * n * sizeof(double)))) == NULL){
                printf("Panic exit ... no memory\n");
                exit(1);
                }
        if((r = (double*)malloc((unsigned)(n * n * sizeof(double)))) == NULL){
                printf("Panic exit ... no memory\n");
                exit(1);
                }
 
        if((work = (double*)malloc((unsigned)(n * sizeof(double)))) == NULL){
                printf("Panic exit ... no memory\n");
                exit(1);
                }
 
        for(i=0;i<n*n;i++)myx[i] = 0;
        i = 0;
        for(j=0;j<n;j++,i += n)myx[i + j] = 1.;
        first = 0;
        }
 
 
     /* multiply x by the current guess */
 
     f01ckf_(myx,myx,x,nn,nn,nn,work,nn,&opt,&i);
 
     /* orthogonalize */
     gs(myx,r,n,n);
 
     /* extract diagonal elements (current estimates of eigenvalues) */
     i = 0;
     for(j=0;j<n;j++,i += n){
        y[j] = r[i + j];
        }
}
